#!/bin/csh -f
set LIBPATH = "/usr/local/lib"
set STATIC_LINKAGE = "$LIBPATH/libgsl.a $LIBPATH/libgslcblas.a"
set SHARED_LINKAGE = "-lgsl -lgslcblas -Wl,--rpath -Wl,$LIBPATH"
echo STATIC_LINKAGE = $STATIC_LINKAGE
echo SHARED_LINKAGE = $SHARED_LINKAGE

foreach makefile (`ls {,src/,src/*/}Makefile`)

 echo ''
 echo Updating $makefile
 awk -v s="$STATIC_LINKAGE" -v d="$SHARED_LINKAGE" '$0!~/^LIBS /{print}/^LIBS /{print "STATIC_LINKAGE =",s;print "SHARED_LINKAGE =",d;print $0,"${SHARED_LINKAGE}"}' $makefile > tmp && mv tmp $makefile

end
