#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>

#define LIPA 0
#define LIPB 1
#define NLIP 2
#define T1 0
#define T2 1
#define NTAIL 2
#define GHOST_SHIFTX 100.0
#define NFNB 6 /* nr nonbonded force types */

typedef struct
{
  int *type;
} mc_ilist;

typedef struct
{
  int nsame;
  int nr[NLIP];
  int first[NLIP];
  int node[NLIP];
  int last[NLIP];
  mc_ilist il[NLIP][NFNB];
} t_tail;

typedef struct
{
  int  nmol;             /* nr of mutable molecs                   */
  int  nr[NLIP];         /* nr of each mutable species             */
  gsl_rng *rng;          /* random number generator                */
  int  kmax;             /* search vectors                         */
  real beta;             /* 1/kT                                   */
  int gtype;             /* Ghost atom type                        */
  real alpha[NLIP];      /* alpha[i]=activity[i]/activity[j]       */
  int size[NLIP];        /* sizes of A and B                       */
  atom_id *first[NLIP];  /* First atom array (dim: NLIP,nmol)      */
  t_tail t[NTAIL];       /* Key indices for each tail              */
} t_mc;

extern bool do_mc(int step, rvec x[], rvec v[], matrix box, t_forcerec *fr,
		t_topology *top, t_inputrec *inputrec, t_mdatoms *mdatoms, 
		t_commrec *cr, t_graph *graph, t_mc *mc, t_groups *grps, t_nrnb *nrnb);

extern void init_mc(t_topology *top, t_inputrec *ir, t_commrec *cr, 
		t_mdatoms *mdatoms, t_graph *graph, rvec x[], rvec v[], 
                matrix box, t_mc *mc, t_forcerec *fr, t_groups *grps, t_nrnb *nrnb);
